unit uAttributes;

interface

uses
  SysUtils, Types, Classes, Variants, QTypes, QGraphics, QControls, QForms, 
  QDialogs, QStdCtrls, QExtCtrls;

type
  TAttributesForm = class(TForm)
    btnOK: TButton;
    btnCancel: TButton;
    btnDefault: TButton;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    edtWidth: TEdit;
    edtHeight: TEdit;
    GroupBox1: TGroupBox;
    RadioButton4: TRadioButton;
    RadioButton5: TRadioButton;
    GroupBox2: TGroupBox;
    RadioButton1: TRadioButton;
    RadioButton2: TRadioButton;
    RadioButton3: TRadioButton;
    Label6: TLabel;
    Label7: TLabel;
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure btnDefaultClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure btnCancelClick(Sender: TObject);
    procedure btnOKClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  AttributesForm: TAttributesForm;

implementation

uses uPaint32;

{$R *.xfm}

procedure TAttributesForm.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
    Action:=caFree;
end;

procedure TAttributesForm.btnDefaultClick(Sender: TObject);
begin
     edtWidth.Text:='640';
     edtHeight.Text:='512';
end;

procedure TAttributesForm.FormCreate(Sender: TObject);
begin
    edtWidth.Text:=IntToStr( frmPaint32.ImgView.Bitmap.Width);
    edtHeight.Text:=IntToStr(frmPaint32.ImgView.Bitmap.Height);


    ActiveControl := edtWidth;
end;

procedure TAttributesForm.btnCancelClick(Sender: TObject);
begin
      edtWidth.Text := IntToStr(frmPaint32.ImgView.Bitmap.Width);
      edtHeight.Text := IntToStr(frmPaint32.ImgView.Bitmap.Height);
end;

procedure TAttributesForm.btnOKClick(Sender: TObject);
begin
      with frmPaint32.ImgView.Bitmap do begin
           Width:=StrToInt(edtWidth.Text);
           Height:=StrToInt(edtHeight.Text);
           SetSize(Width, Height);
           //Bitmap32ToBitmap(frmPaint32.ImgView.Bitmap,frmPaint32.imgBackground.Picture.Bitmap);
           Clear(frmPaint32.pnlColorBG.Color);
           //BitmapToBitmap32(frmPaint32.imgBackground.Picture.Bitmap,frmPaint32.ImgView.Bitmap);
      end;

end;

end.
