unit uPaint32;

interface

uses
  Types, SysUtils, Classes, QForms, QDialogs, QMenus, QTypes, QStdCtrls,
  QControls, QExtCtrls, QGraphics, QComCtrls, GR32, GR32_Image, GR32_Layers,
  GR32_RangeBars, GR32_Filters, GR32_Transforms, GR32_LowLevel,Qt, QButtons,
  math, uXPStyleConsts, uRegistry, uXPIPC, uXPAPI, SelectionRectangle, QClipbrd;

const DefaultFileName='untitled.bmp';
      MaxPixelCount = 32768;
      crPen=102;
      crCross2=103;
      crGetColor=104;

      crFill=105;

      crSpray=106;

      crZoom=107;

      crWinDefault=108;

      crErase4=109;

      crErase6=110;
      crErase8=111;
      crErase10=112;

type
  TDrawType = (dtSelectFreeArea, dtSelectArea, dtEraser, dtFill, dtGetColor,
               dtZoom, dtFreeHand, dtBrush, dtSpray, dtText, dtLine, dtCurve,
               dtRect, dtPolyRect, dtCircle, dtRoundRect, dtPasteRegion);

type TTransparenceMode = (tmSolid, tmTransparent);

type
  TfrmPaint32 = class(TForm)
    ColorBox: TPanel;
    Panel1: TPanel;
    pnlColorBG: TPanel;
    pnlColorFG: TPanel;
    pnlColor1: TPanel;
    pnlColor2: TPanel;
    pnlColor3: TPanel;
    pnlColor4: TPanel;
    pnlColor5: TPanel;
    pnlColor7: TPanel;
    pnlColor9: TPanel;
    pnlColor11: TPanel;
    pnlColor13: TPanel;
    pnlColor15: TPanel;
    pnlColor17: TPanel;
    pnlColor19: TPanel;
    pnlColor21: TPanel;
    pnlColor23: TPanel;
    pnlColor25: TPanel;
    pnlColor27: TPanel;
    pnlColor6: TPanel;
    pnlColor8: TPanel;
    pnlColor10: TPanel;
    pnlColor12: TPanel;
    pnlColor14: TPanel;
    pnlColor16: TPanel;
    pnlColor18: TPanel;
    pnlColor20: TPanel;
    pnlColor22: TPanel;
    pnlColor24: TPanel;
    pnlColor26: TPanel;
    pnlColor28: TPanel;
    StatusBar: TStatusBar;
    Toolbox: TPanel;
    btnSelectFreeArea: TSpeedButton;
    btnSelectArea: TSpeedButton;
    btnEraser: TSpeedButton;
    btnFill: TSpeedButton;
    btnGetColor: TSpeedButton;
    btnZoom: TSpeedButton;
    btnPen: TSpeedButton;
    btnBrush: TSpeedButton;
    btnRect: TSpeedButton;
    btnPolyRect: TSpeedButton;
    btnCircle: TSpeedButton;
    btnRoundRect: TSpeedButton;
    btnLine: TSpeedButton;
    btnCurve: TSpeedButton;
    btnSpray: TSpeedButton;
    btnText: TSpeedButton;
    pnlOptions: TPanel;
    imgOptions: TImage;
    imgSpray1_black: TImage;
    imgSpray2_black: TImage;
    imgSpray3_black: TImage;
    imgSpray1_white: TImage;
    imgSpray2_white: TImage;
    imgSpray3_white: TImage;
    imgErase4: TImage;
    imgErase6: TImage;
    imgErase8: TImage;
    imgErase10: TImage;
    imgPen: TImage;
    imgGetColor: TImage;
    imgCross2: TImage;
    imgFill: TImage;
    imgSpray: TImage;
    imgZoom: TImage;
    imgWinDefault: TImage;
    imgSlctTrans: TImage;
    imgSlctSolid: TImage;
    ColorDialog: TColorDialog;
    MainMenu: TMainMenu;
    mnuFile: TMenuItem;
    mnuNew: TMenuItem;
    Open1: TMenuItem;
    mnuSave: TMenuItem;
    mnuSaveAs: TMenuItem;
    N1: TMenuItem;
    FromScannerorCamera1: TMenuItem;
    N2: TMenuItem;
    PrintPreview1: TMenuItem;
    PageSetup1: TMenuItem;
    Print1: TMenuItem;
    N3: TMenuItem;
    Send1: TMenuItem;
    N4: TMenuItem;
    mnuSetasBackgroundTiled: TMenuItem;
    mnuSetasBackgroundCentered: TMenuItem;
    N5: TMenuItem;
    mnuClose: TMenuItem;
    Edit1: TMenuItem;
    mnuUndo: TMenuItem;
    Repeate1: TMenuItem;
    N6: TMenuItem;
    Cut1: TMenuItem;
    Copy1: TMenuItem;
    Paste1: TMenuItem;
    ClearSelection1: TMenuItem;
    SelectAll1: TMenuItem;
    N7: TMenuItem;
    CopyTo1: TMenuItem;
    PasteFrom1: TMenuItem;
    View1: TMenuItem;
    mnuToolBox: TMenuItem;
    mnuColorBox: TMenuItem;
    mnuStatusBar: TMenuItem;
    TextToolbar1: TMenuItem;
    N8: TMenuItem;
    Zoom1: TMenuItem;
    NormalSize1: TMenuItem;
    LargeSize1: TMenuItem;
    Custom1: TMenuItem;
    N9: TMenuItem;
    ShowGrid1: TMenuItem;
    ShowThumbnail1: TMenuItem;
    ViewBitmap1: TMenuItem;
    muImage: TMenuItem;
    FlipRotate1: TMenuItem;
    StretchSkew1: TMenuItem;
    InvertColors1: TMenuItem;
    Attributes1: TMenuItem;
    mnuClearImage: TMenuItem;
    DrawOpaque1: TMenuItem;
    Colors1: TMenuItem;
    EditColors1: TMenuItem;
    mnuHelp: TMenuItem;
    HelpTopics1: TMenuItem;
    N10: TMenuItem;
    mnuHelpAbout: TMenuItem;
    SaveDialog: TSaveDialog;
    OpenDialog: TOpenDialog;
    imgBackground: TImage;
    ImgView: TImgView32;
    TrackBar1: TTrackBar;
    img32Tmp: TImage32;
    function ColorSwap(WinColor: TColor): TColor32;
    procedure SetDrawType(Sender: TObject);
    procedure DrawRectTool(Y: Integer);
    procedure DrawEraseTool(Y: Integer);
    procedure DrawSprayTool(X,Y: Integer);
    procedure DrawLineTool(Y: Integer);
    procedure DrawTransparentTool(Y: Integer);
    procedure DrawZoomTool(Y: Integer);
    procedure ClearOptionsPanel;
    procedure FloodFill(bitmap: TBitmap32; X,Y: integer; oldcolor, newcolor: TColor32);
    procedure Fill(X,Y: integer;Button: TMouseButton);
    procedure OpenImage(const FileName: string);
    procedure ImgViewMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer; Layer: TCustomLayer);
    procedure ImgViewMouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer; Layer: TCustomLayer);
    procedure ImgViewPaintStage(Sender: TObject; Buffer: TBitmap32;
      StageNum: Cardinal);
    procedure FormCreate(Sender: TObject);
    function CreatePositionedLayer: TPositionedLayer;
    procedure LayerMouseDown(Sender: TObject; Buttons: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure pnlColor1DblClick(Sender: TObject);
    procedure Panel1Click(Sender: TObject);
    procedure pnlColor1MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure Open1Click(Sender: TObject);
    procedure PasteFrom1Click(Sender: TObject);
    procedure mnuNewClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure EditColors1Click(Sender: TObject);
    procedure mnuHelpAboutClick(Sender: TObject);
    procedure mnuSaveClick(Sender: TObject);
    procedure mnuSaveAsClick(Sender: TObject);
    procedure mnuCloseClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure SaveSettings;
    procedure ShowMagnifier(X,Y: integer);
    procedure SetBrushColors(Button: TMouseButton);
    procedure GetColor(Button: TMouseButton; X, Y: Integer);
    procedure imgOptionsMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure ImgViewMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer; Layer: TCustomLayer);
    procedure DrawFreeHand(OldPos, NewPos: TPoint;  Button: TMouseButton);
    procedure DrawLine(TopLeft, BottomRight: TPoint;  Button: TMouseButton; AMode: TPenMode);
    procedure DrawRect(TopLeft, BottomRight: TPoint; Button: TMouseButton; AMode: TPenMode);
    procedure DrawRoundRect(TopLeft1, BottomRight1: TPoint;  Button: TMouseButton; AMode1: TPenMode);
    procedure DrawCircle(TopLeft, BottomRight: TPoint;  Button: TMouseButton; AMode: TPenMode);
    procedure Spray(Canvas: TCanvas; x, y, r: Integer; Color: TColor);
    procedure ColorBoxMouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure ImgViewMouseWheelUp(Sender: TObject; Shift: TShiftState;
      MousePos: TPoint; var Handled: Boolean);
    procedure ImgViewMouseWheelDown(Sender: TObject; Shift: TShiftState;
      MousePos: TPoint; var Handled: Boolean);
    procedure TrackBar1Change(Sender: TObject);
    procedure Copy1Click(Sender: TObject);
    procedure ImgViewDblClick(Sender: TObject);
    procedure Attributes1Click(Sender: TObject);
    procedure FlipRotate1Click(Sender: TObject);
    procedure StretchSkew1Click(Sender: TObject);
  private
    { Private declarations }
    FSelection: TPositionedLayer;
    procedure SetSelection(Value: TPositionedLayer);
    procedure SetBrushType;
    procedure Bitmap32ToBitmap(Src:TBitmap32;Dest:TBitmap);
    procedure BitmapToBitmap32(Src:TBitmap;Dest:TBitmap32);

  protected
   { Protected declarations }
    RBLayer: TRubberbandLayer;
    procedure RBResizing(Sender: TObject; const OldLocation: TFloatRect; var NewLocation: TFloatRect; DragState: TDragState; Shift: TShiftState);

  public
    { Public declarations }
    property Selection: TPositionedLayer read FSelection write SetSelection;
  end;

var
  frmPaint32: TfrmPaint32;
  L: TPositionedLayer;
  MDrawing: Boolean;
  MModified: Boolean;
  MSelect: Boolean;
  Origin: TPoint;
  MovePt: TPoint;
  MouseButton: TMouseButton;
  MouseLastPos: TPoint;
  ColorBG : TColor32;
  ColorFG : TColor32;
  gLineWidth: integer;
  IsNew: boolean;
  BrushType: integer;
  MDrawType: TDrawType;
  PreviousTool: TObject;
  LastSelectedRect:integer;
  LastSelectedRoundRect:integer;
  LastSelectedCircle:integer;
  LastSelectedPolyRect:integer;
  LastSelectedErase:integer;
  LastSelectedSpray:integer;
  LastSelectedLine:integer;
  LastSelectedZoom:integer;
  EraserHeight:integer;
  SprayR : Integer;
  SprayDens: integer;
  TransparenceMode: TTransparenceMode;
  Dx,Dy: integer;
  Layer: TBitmapLayer;


 // RStyle: SelectionRectangle.TResizeStyle;

implementation

uses uAttributes, uFlip, uStretch;

{$R *.xfm}

procedure TfrmPaint32.Bitmap32ToBitmap(Src:TBitmap32;Dest:TBitmap);
var i,j: integer;
    RowSrc: PColor32Array;
    RowDest: PColor32Array;
begin
      for i:=0  to Src.Height-1 do begin
          RowSrc:=Src.ScanLine[i];
          RowDest:=Dest.ScanLine[i];
          for  j:=0  to Src.Width-1 do begin
                 RowDest[j]:=RowSrc[j];
          end;
      end;
end;

procedure TfrmPaint32.BitmapToBitmap32(Src:TBitmap;Dest:TBitmap32);
var i,j: integer;
    RowSrc: PColor32Array;
    RowDest: PColor32Array;
begin
      for i:=0  to Src.Height-1 do begin
          RowSrc:=Src.ScanLine[i];
          RowDest:=Dest.ScanLine[i];
          for  j:=0  to Src.Width-1 do begin
                 RowDest[j]:=RowSrc[j];
          end;
      end;
end;


procedure TfrmPaint32.GetColor(Button: TMouseButton; X, Y: Integer);
begin
      try
        if Button=mbLeft then begin
           pnlColorFG.Color:=ImgView.Canvas.Pixels[X,Y];
           ColorFG:=Color32(pnlColorFG.Color);
           ImgView.Canvas.Pen.Color :=ColorFG;
        end
        else if Button=mbRight then begin
           pnlColorBG.Color:=ImgView.Canvas.Pixels[X,Y];
           ColorBG:=Color32(pnlColorBG.Color);
           ImgView.Canvas.Brush.Color :=ColorBG;
        end;
        pnlOptions.Color:=clBackground;
      except

      end;
end;

procedure TfrmPaint32.ShowMagnifier(X,Y: integer);
begin
      ImgView.Cursor:=crZoom;
end;

procedure TfrmPaint32.SetBrushType;
begin
     case BrushType of
            1: ImgView.Bitmap.Canvas.Brush.Style:=bsClear;
            2: ImgView.Bitmap.Canvas.Brush.Style:=bsSolid;
            3: ImgView.Bitmap.Canvas.Brush.Style:=bsSolid;
     end;
end;

procedure TfrmPaint32.SetBrushColors(Button: TMouseButton);
begin
     if Button=mbLeft then begin
           if BrushType=3 then begin
               ImgView.Bitmap.Canvas.Pen.Color:=pnlColorFG.Color;
               ImgView.Bitmap.Canvas.Brush.Color:=pnlColorFG.Color;
            end
            else begin
               ImgView.Bitmap.Canvas.Pen.Color:=pnlColorFG.Color;
               ImgView.Bitmap.Canvas.Brush.Color:=pnlColorBG.Color;
            end;
     end
     else if Button=mbRight then begin
           if BrushType=3 then begin
               ImgView.Bitmap.Canvas.Pen.Color:=pnlColorBG.Color;
               ImgView.Bitmap.Canvas.Brush.Color:=pnlColorBG.Color;
            end
            else begin
               ImgView.Bitmap.Canvas.Pen.Color:=pnlColorBG.Color;
               ImgView.Bitmap.Canvas.Brush.Color:=pnlColorFG.Color;
            end;
     end;
end;

procedure TfrmPaint32.Spray(Canvas: TCanvas; x, y, r: Integer; Color: TColor);
var
  rad, a: Single;
  i: Integer;
begin
  for i := 0 to SprayDens do
  begin
    a   := Random * 2 * pi;
    rad := Random * r;
    ImgView.Bitmap.Canvas.Pixels[x + Round(rad * Cos(a)), y + Round(rad * Sin(a))] := Color;
  end;
end;

procedure TfrmPaint32.DrawRect(TopLeft, BottomRight: TPoint; Button: TMouseButton; AMode: TPenMode);
var backgroundRect: TRect;
begin
     ImgView.Canvas.Pen.Style:=psSolid;
     SetBrushType;
     SetBrushColors(Button);
     ImgView.Bitmap.Canvas.Pen.Width:=gLineWidth;
     ImgView.Bitmap.Canvas.Pen.Mode := AMode;
     ImgView.Bitmap.Canvas.Draw(0,0,imgBackground.Picture.Graphic);
     ImgView.Bitmap.Canvas.Rectangle(TopLeft.X,TopLeft.Y,BottomRight.X,BottomRight.Y);
     MModified:=True;
end;

procedure TfrmPaint32.DrawRoundRect(TopLeft1, BottomRight1: TPoint;  Button: TMouseButton; AMode1: TPenMode);
begin
     ImgView.Bitmap.Canvas.Pen.Style:=psSolid;
     SetBrushType;
     ImgView.Bitmap.Canvas.Pen.Width:=gLineWidth;
     SetBrushColors(Button);
     ImgView.Bitmap.Canvas.Pen.Mode := AMode1;
     ImgView.Bitmap.Canvas.Draw(0,0,imgBackground.Picture.Graphic);
     ImgView.Bitmap.Canvas.RoundRect(TopLeft1.X,TopLeft1.Y,BottomRight1.X,BottomRight1.Y,
                            Abs((TopLeft1.X-BottomRight1.X) div 2),
                            Abs((TopLeft1.Y-BottomRight1.Y) div 2));
     MModified:=True;
end;

procedure TfrmPaint32.DrawCircle(TopLeft, BottomRight: TPoint;  Button: TMouseButton; AMode: TPenMode);
begin
     ImgView.Bitmap.Canvas.Pen.Style:=psSolid;
     SetBrushType;
     ImgView.Bitmap.Canvas.Pen.Width:=gLineWidth;
     SetBrushColors(Button);
     ImgView.Bitmap.Canvas.Pen.Mode := AMode;
     ImgView.Bitmap.Canvas.Draw(0,0,imgBackground.Picture.Graphic);
     ImgView.Bitmap.Canvas.Ellipse(TopLeft.X,TopLeft.Y,BottomRight.X,BottomRight.Y);
     MModified:=True;
end;

procedure TfrmPaint32.DrawLine(TopLeft, BottomRight: TPoint;  Button: TMouseButton; AMode: TPenMode);
begin
     ImgView.Bitmap.Canvas.Brush.Style:=bsSolid;
     ImgView.Bitmap.Canvas.Pen.Style:=psSolid;
     ImgView.Bitmap.Canvas.Pen.Width:=gLineWidth;
     ImgView.Bitmap.Canvas.Pen.Mode := AMode;
     SetBrushType;
     
     if Button=mbLeft then ImgView.Bitmap.Canvas.Pen.Color:=pnlColorFG.Color
     else if Button=mbRight then ImgView.Bitmap.Canvas.Pen.Color:=pnlColorBG.Color;

     ImgView.Bitmap.Canvas.Draw(0,0,imgBackground.Picture.Graphic);
     ImgView.Bitmap.Canvas.MoveTo(TopLeft.X,TopLeft.Y);
     ImgView.Bitmap.Canvas.LineTo(BottomRight.X,BottomRight.Y);
     MModified:=True;
end;

procedure TfrmPaint32.DrawFreeHand(OldPos, NewPos: TPoint;  Button: TMouseButton);
begin
     if Button=mbLeft then ImgView.Bitmap.Canvas.Pen.Color:=pnlColorFG.Color
     else if Button=mbRight then ImgView.Bitmap.Canvas.Pen.Color:=pnlColorBG.Color;
     ImgView.Bitmap.Canvas.Pen.Style:=psSolid;
     ImgView.Bitmap.Canvas.Pen.Width:=1;
     ImgView.Bitmap.Canvas.MoveTo(OldPos.X,OldPos.Y);
     ImgView.Bitmap.Canvas.LineTo(NewPos.X,NewPos.Y);
     MModified:=True;
end;

procedure TfrmPaint32.DrawRectTool(Y: Integer);
begin
     imgOptions.Visible:=True;
     imgOptions.Canvas.Pen.Width:=1;
     imgOptions.Canvas.Pen.Color:=clNormalHighlight;
     imgOptions.Canvas.Brush.Color:=clNormalHighlight;
     with imgOptions.Canvas do
     begin
         if (Y>2) and (Y<21) then begin
              ClearOptionsPanel;
              Pen.Color:=$00A44010;
              Brush.Color:=clGray;
              Rectangle(0,1,imgOptions.Width,22);
              Pen.Color:=$00A44010;
              Rectangle(5,6,36,17);
              Pen.Color:=$00A44010;
              Brush.Color:=clWhite;
              Rectangle(6,26,36,38);
              Brush.Color:=clWhite;
              Pen.Color:=clWhite;
              Rectangle(6,46,36,58);
              BrushType:=1;
                if MDrawType = dtRect then LastSelectedRect:=1;
                if MDrawType = dtRoundRect then LastSelectedRoundRect:=1;
                if MDrawType = dtCircle then LastSelectedCircle:=1;
                if MDrawType = dtPolyRect then LastSelectedPolyRect:=1;
         end
         else if (Y>23) and (Y<42) then begin
              ClearOptionsPanel;
              Pen.Color:=$00A44010;
              Brush.Color:=clBackground;
              Rectangle(5,6,36,17);
              Pen.Color:=clGray;
              Brush.Color:=clGray;
              Rectangle(0,21,imgOptions.Width,43);
              Brush.Color:=clGray;
              Pen.Color:=$00A44010;
              Brush.Color:=clWhite;
              Rectangle(6,26,36,38);
              Pen.Color:=clWhite;
              Rectangle(6,46,36,58);
              BrushType:=2;
                if MDrawType = dtRect then LastSelectedRect:=2;
                if MDrawType = dtRoundRect then LastSelectedRoundRect:=2;
                if MDrawType = dtCircle then LastSelectedCircle:=2;
                if MDrawType = dtPolyRect then LastSelectedPolyRect:=2;

         end
         else if (Y>43) and (Y<61) then begin
              ClearOptionsPanel;
              Pen.Color:=$00A44010;
              Brush.Color:=clWhite;
              Rectangle(5,6,36,17);
              Pen.Color:=$00A44010;
              Brush.Color:=clWhite;
              Rectangle(6,26,36,38);
              Pen.Color:=clGray;
              Brush.Color:=clGray;
              Rectangle(0,42,imgOptions.Width,62);
              Pen.Color:=clWhite;
              Brush.Color:=clWhite;
              Rectangle(6,46,36,58);
              BrushType:=3;
                if MDrawType = dtRect then LastSelectedRect:=3;
                if MDrawType = dtRoundRect then LastSelectedRoundRect:=3;
                if MDrawType = dtCircle then LastSelectedCircle:=3;
                if MDrawType = dtPolyRect then LastSelectedPolyRect:=3;
         end;
     end;

end;

procedure TfrmPaint32.DrawZoomTool(Y: Integer);
begin
     imgOptions.Visible:=True;
     with imgOptions.Canvas do
     begin
        if (Y>2) and (Y<13) then begin
           ClearOptionsPanel;
           Pen.Color:=clNormalHighlight;
           Brush.Color:=clNormalHighlight;
           Rectangle(0,1,imgOptions.Width,13);
           Font.Color:=clWhite;
           Font.Size:=8;
           Font.Style:=[fsBold];
           TextOut(14,0,'1x');
           Pen.Color:=$00A44010;
           Brush.Color:=$00A44010;
           Font.Color:=$00A44010;
           Font.Size:=8;
           Font.Style:=[];
           TextOut(14,14,'2x');
           TextOut(14,30,'6x');
           TextOut(14,48,'8x');
           ImgView.Scale:=1;
           if MDrawType = dtZoom then LastSelectedZoom:=1;
        end;
        if (Y>14) and (Y<25) then begin
           ClearOptionsPanel;
           Font.Color:=$00A44010;
           Font.Size:=8;
           Font.Style:=[];
           TextOut(14,0,'1x');
           Pen.Color:=clNormalHighlight;
           Brush.Color:=clNormalHighlight;
           Rectangle(0,15,imgOptions.Width,27);
           Font.Color:=clWhite;
           Font.Size:=8;
           Font.Style:=[fsBold];
           TextOut(14,14,'2x');
           Font.Color:=$00A44010;
           Font.Size:=8;
           Font.Style:=[];
           TextOut(14,30,'6x');
           TextOut(14,48,'8x');
           ImgView.Scale:=2;
           if MDrawType = dtZoom then LastSelectedZoom:=2;
        end;
        if (Y>26) and (Y<44) then begin
           ClearOptionsPanel;
           Font.Color:=$00A44010;
           Font.Size:=8;
           Font.Style:=[];
           TextOut(14,0,'1x');
           TextOut(14,14,'2x');
           Pen.Color:=clNormalHighlight;
           Brush.Color:=clNormalHighlight;
           Rectangle(0,30,imgOptions.Width,44);
           Font.Color:=clWhite;
           Font.Size:=8;
           Font.Style:=[fsBold];
           TextOut(14,30,'6x');
           Font.Color:=$00A44010;
           Font.Size:=8;
           Font.Style:=[];
           TextOut(14,48,'8x');
           ImgView.Scale:=6;
           //ImgView.Cursor:=crErase8;
           if MDrawType = dtZoom then LastSelectedZoom:=3;
        end;
        if (Y>45) and (Y<63) then begin
           ClearOptionsPanel;
           Font.Color:=$00A44010;
           Font.Size:=8;
           Font.Style:=[];
           TextOut(14,0,'1x');
           TextOut(14,14,'2x');
           TextOut(14,30,'6x');
           Pen.Color:=clNormalHighlight;
           Brush.Color:=clNormalHighlight;
           Rectangle(0,47,imgOptions.Width,63);
           Font.Color:=clWhite;
           Font.Size:=8;
           Font.Style:=[fsBold];
           TextOut(14,48,'8x');
           ImgView.Scale:=8;
           //ImgView.Cursor:=crErase10;
           if MDrawType = dtZoom then LastSelectedZoom:=4;
        end;

     end;

end;

procedure TfrmPaint32.DrawEraseTool(Y: Integer);
begin
     imgOptions.Visible:=True;
     with imgOptions.Canvas do
     begin
        if (Y>2) and (Y<13) then begin
           ClearOptionsPanel;
           Pen.Color:=clNormalHighlight;
           Brush.Color:=clNormalHighlight;
           Rectangle(14,1,30,13);
           Pen.Color:=clWhite;
           Brush.Color:=clWhite;
           Rectangle(20,5,24,9);
           Pen.Color:=$00A44010;
           Brush.Color:=$00A44010;
           Rectangle(19,18,25,24);
           Rectangle(18,33,26,41);
           Rectangle(17,50,27,60);
           EraserHeight:=4;
           ImgView.Cursor:=crErase4;
           if MDrawType = dtEraser then LastSelectedErase:=1;
        end;
        if (Y>14) and (Y<25) then begin
           ClearOptionsPanel;
           Pen.Color:=$00A44010;
           Brush.Color:=$00A44010;
           Rectangle(20,5,24,9);
           Pen.Color:=clNormalHighlight;
           Brush.Color:=clNormalHighlight;
           Rectangle(14,15,30,27);
           Pen.Color:=clWhite;
           Brush.Color:=clWhite;
           Rectangle(19,18,25,24);
           Pen.Color:=$00A44010;
           Brush.Color:=$00A44010;
           Rectangle(18,33,26,41);
           Rectangle(17,50,27,60);
           EraserHeight:=6;
           ImgView.Cursor:=crErase6;
           if MDrawType = dtEraser then LastSelectedErase:=2;
        end;
        if (Y>26) and (Y<44) then begin
           ClearOptionsPanel;
           Pen.Color:=$00A44010;
           Brush.Color:=$00A44010;
           Rectangle(20,5,24,9);
           Rectangle(19,18,25,24);
           Pen.Color:=clNormalHighlight;
           Brush.Color:=clNormalHighlight;
           Rectangle(14,30,30,44);
           Pen.Color:=clWhite;
           Brush.Color:=clWhite;
           Rectangle(18,33,26,41);
           Pen.Color:=$00A44010;
           Brush.Color:=$00A44010;
           Rectangle(17,50,27,60);
           EraserHeight:=8;
           ImgView.Cursor:=crErase8;
           if MDrawType = dtEraser then LastSelectedErase:=3;
        end;
        if (Y>45) and (Y<63) then begin
           ClearOptionsPanel;
           Pen.Color:=$00A44010;
           Brush.Color:=$00A44010;
           Rectangle(20,5,24,9);
           Rectangle(19,18,25,24);
           Rectangle(18,33,26,41);
           Pen.Color:=clNormalHighlight;
           Brush.Color:=clNormalHighlight;
           Rectangle(14,47,30,63);
           Pen.Color:=clWhite;
           Brush.Color:=clWhite;
           Rectangle(17,50,27,60);
           EraserHeight:=10;
           ImgView.Cursor:=crErase10;
           if MDrawType = dtEraser then LastSelectedErase:=4;
        end;

     end;

end;


procedure TfrmPaint32.DrawSprayTool(X,Y: Integer);
begin
     imgOptions.Visible:=True;
     with imgOptions.Canvas do
     begin
     if ((Y>2) and (Y<25)) and ((X>2) and (X<20)) then begin
           ClearOptionsPanel;
           Pen.Color:=clNormalHighlight;
           Brush.Color:=clNormalHighlight;
           Rectangle(0,1,imgOptions.Width div 2,24);
           Draw(6,8,imgSpray1_white.Picture.Bitmap);
           Draw(24,6,imgSpray2_black.Picture.Bitmap);
           Draw(10,28,imgSpray3_black.Picture.Bitmap);
           SprayR:=10;
           SprayDens:=10;
           if MDrawType = dtSpray then LastSelectedSpray:=1;
     end;

     if ((Y>2) and (Y<25)) and ((X>21) and (X<40)) then begin
           ClearOptionsPanel;
           Pen.Color:=clNormalHighlight;
           Brush.Color:=clNormalHighlight;
           Draw(6,8,imgSpray1_black.Picture.Bitmap);
           Rectangle(21,1,imgOptions.Width,24);
           Draw(24,6,imgSpray2_white.Picture.Bitmap);
           Draw(10,28,imgSpray3_black.Picture.Bitmap);
           SprayR:=15;
           SprayDens:=50;
           if MDrawType = dtSpray then LastSelectedSpray:=2;
     end;

     if ((Y>26) and (Y<65)) and ((X>1) and (X<40)) then begin
           ClearOptionsPanel;
           Pen.Color:=clNormalHighlight;
           Brush.Color:=clNormalHighlight;
           Draw(6,8,imgSpray1_black.Picture.Bitmap);
           Draw(24,6,imgSpray2_black.Picture.Bitmap);
           Rectangle(8,26,36,55);
           Draw(10,28,imgSpray3_white.Picture.Bitmap);
           SprayR:=30;
           SprayDens:=200;
           if MDrawType = dtSpray then LastSelectedSpray:=3;
     end;

     end;
end;


procedure TfrmPaint32.DrawLineTool(Y: Integer);
begin
     imgOptions.Visible:=True;
     with imgOptions.Canvas do
     begin
           if (Y>2) and (Y<11) then begin
               ClearOptionsPanel;
               Pen.Color:=clNormalHighlight;
               Brush.Color:=clNormalHighlight;
               Rectangle(0,1,imgOptions.Width,12);
               // Line width 1 pixel
                 Pen.Width:=1;
                 Pen.Color:=clWhite;
                 MoveTo(7,6);
                 LineTo(37,6);
               // Line width 2 pixel
                 Pen.Width:=2;
                 Pen.Color:=$00A44010;
                 MoveTo(7,18);
                 LineTo(37,18);
               // Line width 3 pixel
                 Pen.Width:=3;
                 Pen.Color:=$00A44010;
                 MoveTo(7,30);
                 LineTo(37,30);
               // Line width 4 pixel
                 Pen.Width:=4;
                 Pen.Color:=$00A44010;
                 MoveTo(7,43);
                 LineTo(37,43);
               // Line width 5 pixel
                 Pen.Width:=5;
                 Pen.Color:=$00A44010;
                 MoveTo(7,55);
                 LineTo(37,55);
                 gLineWidth:=1;
                 if MDrawType = dtLine then LastSelectedLine:=1;
           end
           else if (Y>12) and (Y<22) then begin
               ClearOptionsPanel;
               // Line width 1 pixel
                 Pen.Width:=1;
                 Pen.Color:=$00A44010;
                 MoveTo(7,6);
                 LineTo(37,6);
               // Line width 2 pixel
               Pen.Color:=clNormalHighlight;
               Brush.Color:=clNormalHighlight;
               Rectangle(0,12,imgOptions.Width,25);
                 Pen.Width:=2;
                 Pen.Color:=clWhite;
                 MoveTo(7,18);
                 LineTo(37,18);
               // Line width 3 pixel
                 Pen.Width:=3;
                 Pen.Color:=$00A44010;
                 MoveTo(7,30);
                 LineTo(37,30);
               // Line width 4 pixel
                 Pen.Width:=4;
                 Pen.Color:=$00A44010;
                 MoveTo(7,43);
                 LineTo(37,43);
               // Line width 5 pixel
                 Pen.Width:=5;
                 Pen.Color:=$00A44010;
                 MoveTo(7,55);
                 LineTo(37,55);
                 gLineWidth:=2;
                 if MDrawType = dtLine then LastSelectedLine:=2;
           end
           else if (Y>22) and (Y<33) then begin
               ClearOptionsPanel;
               // Line width 1 pixel
                 Pen.Width:=1;
                 Pen.Color:=$00A44010;
                 MoveTo(7,6);
                 LineTo(37,6);
               // Line width 2 pixel
                 Pen.Width:=2;
                 Pen.Color:=$00A44010;
                 MoveTo(7,18);
                 LineTo(37,18);
               // Line width 3 pixel
               Pen.Color:=clNormalHighlight;
               Brush.Color:=clNormalHighlight;
               Rectangle(0,24,imgOptions.Width,38);
                 Pen.Width:=3;
                 Pen.Color:=clWhite;
                 MoveTo(7,30);
                 LineTo(37,30);
               // Line width 4 pixel
                 Pen.Width:=4;
                 Pen.Color:=$00A44010;
                 MoveTo(7,43);
                 LineTo(37,43);
               // Line width 5 pixel
                 Pen.Width:=5;
                 Pen.Color:=$00A44010;
                 MoveTo(7,55);
                 LineTo(37,55);
                 gLineWidth:=3;
                 if MDrawType = dtLine then LastSelectedLine:=3;
           end
           else if (Y>33) and (Y<46) then begin
               ClearOptionsPanel;
               // Line width 1 pixel
                 Pen.Width:=1;
                 Pen.Color:=$00A44010;
                 MoveTo(7,6);
                 LineTo(37,6);
               // Line width 2 pixel
                 Pen.Width:=2;
                 Pen.Color:=$00A44010;
                 MoveTo(7,18);
                 LineTo(37,18);
               // Line width 3 pixel
                 Pen.Width:=3;
                 Pen.Color:=$00A44010;
                 MoveTo(7,30);
                 LineTo(37,30);
               // Line width 4 pixel
               Pen.Color:=clNormalHighlight;
               Brush.Color:=clNormalHighlight;
               Rectangle(0,36,imgOptions.Width,49);
                 Pen.Width:=4;
                 Pen.Color:=clWhite;
                 MoveTo(7,43);
                 LineTo(37,43);
               // Line width 5 pixel
                 Pen.Width:=5;
                 Pen.Color:=$00A44010;
                 MoveTo(7,55);
                 LineTo(37,55);
                 gLineWidth:=4;
                 if MDrawType = dtLine then LastSelectedLine:=4;
           end
           else if (Y>47) and (Y<57) then begin
               ClearOptionsPanel;
               // Line width 1 pixel
                 Pen.Width:=1;
                 Pen.Color:=$00A44010;
                 MoveTo(7,6);
                 LineTo(37,6);
               // Line width 2 pixel
                 Pen.Width:=2;
                 Pen.Color:=$00A44010;
                 MoveTo(7,18);
                 LineTo(37,18);
               // Line width 3 pixel
                 Pen.Width:=3;
                 Pen.Color:=$00A44010;
                 MoveTo(7,30);
                 LineTo(37,30);
               // Line width 4 pixel
                 Pen.Width:=4;
                 Pen.Color:=$00A44010;
                 MoveTo(7,43);
                 LineTo(37,43);
               // Line width 5 pixel
               Pen.Color:=clNormalHighlight;
               Brush.Color:=clNormalHighlight;
               Rectangle(0,50,imgOptions.Width,62);
                 Pen.Width:=5;
                 Pen.Color:=clWhite;
                 MoveTo(7,55);
                 LineTo(37,55);
                 gLineWidth:=5;
                 if MDrawType = dtLine then LastSelectedLine:=5;
           end;
     end;

end;


procedure TfrmPaint32.DrawTransparentTool(Y: Integer);
var  TrColor: TColor32;
     i: integer;
begin
     ClearOptionsPanel;
     imgOptions.Visible:=True;
     imgOptions.Canvas.Pen.Color:=clNormalHighlight;
     imgOptions.Canvas.Brush.Color:=clNormalHighlight;
     if Y< imgSlctSolid.Height+1 then begin
          with imgOptions.Canvas do
          begin
              Rectangle(0,1,imgOptions.Width,30);
              Draw(4,4,imgSlctSolid.Picture.Bitmap);
              Draw(4,34,imgSlctTrans.Picture.Bitmap);
              try
                 Layer.Bitmap:=img32Tmp.Bitmap;
                 
              except

              end;
              TransparenceMode:= tmSolid;
          end;
      end
      else begin
          with imgOptions.Canvas do
          begin
              Rectangle(0,31,imgOptions.Width,60);
              Draw(4,4,imgSlctSolid.Picture.Bitmap);
              Draw(4,34,imgSlctTrans.Picture.Bitmap);
               //Transparent
               TrColor:=Color32(pnlColorBG.Color);
               img32Tmp.Bitmap:=Layer.Bitmap;
               with Layer.Bitmap do begin
                 for i:=0 to Width*Height-1 do
                    if (Bits[i] and $00FFFFFF)=(TrColor and $00FFFFFF)
                    then Bits[i]:= $00FFFFFF and Bits[i];
                    Changed;
                end;
                TransparenceMode:= tmTransparent;

          end;
      end;

end;


procedure TfrmPaint32.ClearOptionsPanel;
begin
      with imgOptions.Canvas do
      begin
          Pen.Color:=clBackground;
          Brush.Color:=clBackground;
          Rectangle(0,0,imgOptions.Width,imgOptions.Height);
      end;
end;


procedure TfrmPaint32.SaveSettings;
    var reg: TRegistry;
begin
    reg := TRegistry.Create;

    try
        if reg.OpenKey('Software/XPde/paint', true) then begin
            reg.Writeinteger('Top', Top);
            reg.Writeinteger('Left', Left);
            reg.Writeinteger('Width', Width);
            reg.Writeinteger('Height', Height);
        end;
    finally
        reg.Free();
    end;
end;


function TfrmPaint32.ColorSwap(WinColor: TColor): TColor32;
begin
  Result := $FF000000 or
    TColor32((WinColor and $0000FF) shl  16) or // R
    TColor32( WinColor and $00FF00) or          // G
    TColor32((WinColor and $FF0000) shr 16);    // B
end;

function TfrmPaint32.CreatePositionedLayer: TPositionedLayer;
var
  P: TPoint;
begin
  // get coordinates of the center of viewport
  with ImgView.GetViewportRect do
    P := ImgView.ControlToBitmap(Point((Right + Left) div 2, (Top + Bottom) div 2));

  Result := TPositionedLayer.Create(ImgView.Layers);
  Result.Location := FloatRect(P.X - 32, P.Y - 32, P.X + 32, P.Y + 32);
  Result.Scaled := True;
  Result.MouseEvents := True;
  Result.OnMouseDown := LayerMouseDown;

end;

procedure TfrmPaint32.LayerMouseDown(Sender: TObject; Buttons: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  if Sender <> nil then Selection := TPositionedLayer(Sender);
end;

procedure TfrmPaint32.FloodFill(Bitmap: TBitmap32; X,Y: integer; oldcolor, newcolor: TColor32);
var Row: PColor32Array;
begin
      try
           if (X<0) or (Y<0) or (X> Bitmap.Width) or (Y>Bitmap.Height) then exit;
           Row:=Bitmap.ScanLine[Y];
           if (Row[X] = oldcolor) and (Row[X] <> newcolor) then begin Row[X] := newcolor;
               FloodFill(Bitmap, X+1,Y,oldcolor, newcolor);
               FloodFill(Bitmap, X,Y-1,oldcolor, newcolor);
               FloodFill(Bitmap, X-1,Y,oldcolor, newcolor);
               FloodFill(Bitmap, X,Y+1,oldcolor, newcolor);
           end;
      except

      end;

end;

procedure TfrmPaint32.Fill(X,Y: integer;Button: TMouseButton);
var Bitmap: TBitmap;
    oldcolor32, newcolor32 :TColor32;
    Row: PColor32Array;
begin
    Row:=ImgView.Bitmap.Scanline[Y];
    oldcolor32:= Row[X];
    if Button=mbLeft then newcolor32:= ColorFG
    else if Button=mbRight then newcolor32:= ColorBG;
    FloodFill(ImgView.Bitmap, x,y,oldcolor32,newcolor32);
    //PaintBox.Canvas.Draw(0,0,ImageWork.Picture.Graphic);
end;

procedure TfrmPaint32.RBResizing(Sender: TObject;
  const OldLocation: TFloatRect; var NewLocation: TFloatRect;
  DragState: TDragState; Shift: TShiftState);
var
  w, h, cx, cy: Single;
  nw, nh: Single;

begin
  if DragState = dsMove then Exit; // we are interested only in scale operations
  if Shift = [] then Exit; // special processing is not required

  if ssCtrl in Shift then
  begin
    { make changes symmetrical }

    with OldLocation do
    begin
      cx := (Left + Right) / 2;
      cy := (Top + Bottom) / 2;
      w := Right - Left;
      h := Bottom - Top;
    end;

    with NewLocation do
    begin
      nw := w / 2;
      nh := h / 2;
      case DragState of
        dsSizeL: nw := cx - Left;
        dsSizeT: nh := cy - Top;
        dsSizeR: nw := Right - cx;
        dsSizeB: nh := Bottom - cy;
        dsSizeTL: begin nw := cx - Left; nh := cy - Top; end;
        dsSizeTR: begin nw := Right - cx; nh := cy - Top; end;
        dsSizeBL: begin nw := cx - Left; nh := Bottom - cy; end;
        dsSizeBR: begin nw := Right - cx; nh := Bottom - cy; end;
      end;
      if nw < 2 then nw := 2;
      if nh < 2 then nh := 2;

      Left := cx - nw;
      Right := cx + nw;
      Top := cy - nh;
      Bottom := cy + nh;
    end;
  end;
end;

procedure TfrmPaint32.SetSelection(Value: TPositionedLayer);
begin
  if Value <> FSelection then
  begin
    if RBLayer <> nil then
    begin
      RBLayer.ChildLayer := nil;
      RBLayer.LayerOptions := LOB_NO_UPDATE;
      //pnlBitmapLayer.Visible := False;
      //pnlMagn.Visible := False;
      ImgView.Invalidate;
    end;

    FSelection := Value;

    if Value <> nil then
    begin
      if RBLayer = nil then
      begin
        RBLayer := TRubberBandLayer.Create(ImgView.Layers);
        RBLayer.MinHeight := 1;
        RBLayer.MinWidth := 1;
      end
      else RBLayer.BringToFront;
      RBLayer.ChildLayer := Value;
      RBLayer.LayerOptions := LOB_VISIBLE or LOB_MOUSE_EVENTS or LOB_NO_UPDATE;
      RBLayer.OnResizing := RBResizing;

      if Value is TBitmapLayer then
        with TBitmapLayer(Value) do
        begin
          //pnlBitmapLayer.Visible := True;
          //LayerOpacity.Position := Bitmap.MasterAlpha;
          //LayerInterpolate.Checked := Bitmap.StretchFilter = sfLinear;
        end
      else if Value.Tag = 2 then
      begin
        // tag = 2 for magnifiers
        //pnlMagn.Visible := True;
      end;
    end;
  end;
end;

procedure TfrmPaint32.OpenImage(const FileName: string);
begin
  IsNew:=True;
  ColorBG:=Color32(clWhite);
  ColorFG:=Color32(clBlack);
  pnlColorFG.Color:=clBlack;
  pnlColorBG.Color:=clWhite;
  with ImgView do
  try
    Selection := nil;
    RBLayer := nil;
    Layers.Clear;
    Scale := 1;
    Bitmap.LoadFromFile(FileName);
    imgBackground.Picture.LoadFromFile(FileName);
  finally

  end;
  SaveDialog.FileName:=FileName;
  Caption:=FileName+' - Paint';

  SprayR:=15;
  SprayDens:=50;
  BrushType:=1;
  LastSelectedRect:=1;
  LastSelectedRoundRect:=1;
  LastSelectedCircle:=1;
  LastSelectedPolyRect:=1;
  LastSelectedErase:=1;
  LastSelectedSpray:=1;
  LastSelectedLine:=1;
  LastSelectedZoom:=1;
  EraserHeight:=4;
  TransparenceMode:= tmSolid;


  PreviousTool:=btnPen;
  btnPen.Down:=True;
  SetDrawType(PreviousTool);
  //DrawZoomTool(3);

end;

procedure TfrmPaint32.ImgViewMouseDown(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer;
  Layer: TCustomLayer);
var myPoint: TPoint;
begin

    myPoint:=ImgView.ControlToBitmap(Point(X,Y));

   //if not Assigned(RBLayer) then begin
   //    myPoint:=ImgView.ControlToBitmap(Point(X,Y));
   //    MouseLastPos:=myPoint;
   //    RBLayer.Location:= FloatRect(myPoint.X, myPoint.Y, myPoint.X, myPoint.Y);
   //end;

      MDrawing := True;
      ImgView.Canvas.MoveTo(myPoint.X,myPoint.Y);
      Origin := Point(myPoint.X,myPoint.Y);
      MovePt := Origin;
      MouseButton:=Button ;

      case MDrawType of
        dtPasteRegion : ;
        dtSelectFreeArea: ;
        dtSelectArea: begin
           { RStyle := Sel.GetResizeStyle(X, Y, 5);
            if (RStyle = rssNone) then begin
              PaintBox.Canvas.Draw(0,0,ImageWork.Picture.Graphic);
              Sel.Hide;
              Sel.StartSelect(Point(X, Y));
            end
            else begin
              if (RStyle = rssMove) then begin
                 Sel.StartMove(Point(X, Y));

              end
              else Sel.StartResize(Point(X, Y), RStyle);
              if (ssCtrl in Shift) then MoveMode:=mmCopy
              else if (ssShift in Shift) then MoveMode:=mmDraw
              else MoveMode:=mmCut;
            end;}
        end;
        dtEraser: begin
            if ssLeft in Shift then begin
                ImgView.Bitmap.Canvas.Brush.Color:=pnlColorBG.Color;
                ImgView.Bitmap.Canvas.Brush.Style:=bsSolid;
                ImgView.Bitmap.Canvas.Pen.Color:=pnlColorBG.Color;
                ImgView.Bitmap.Canvas.Rectangle(myPoint.X,myPoint.Y,myPoint.X+EraserHeight,myPoint.Y+EraserHeight);
                {Bitmap32ToBitmap(ImgView.Bitmap,imgBackground.Picture.Bitmap);
                BitmapToBitmap32(imgBackground.Picture.Bitmap,ImgView.Bitmap);}
            end;
        end;
        dtFill: begin
             ImgView.BeginUpdate;
             Fill(myPoint.X,myPoint.Y,Button);
             ImgView.EndUpdate;
             ImgView.Changed;
             Bitmap32ToBitmap(ImgView.Bitmap,imgBackground.Picture.Bitmap);
        end;
        dtGetColor: begin
               imgOptions.Visible:=False;
               pnlOptions.Color:=ImgView.Canvas.Pixels[X,Y];
        end;
        dtZoom: ;
        dtFreeHand: begin
            if Button=mbLeft then ImgView.Bitmap.Canvas.Pixels[myPoint.X,myPoint.Y]:=pnlColorFG.Color
            else if Button=mbRight then ImgView.Bitmap.Canvas.Pixels[myPoint.X,myPoint.Y]:=pnlColorBG.Color;
            Origin := Point(myPoint.X,myPoint.Y);
            MovePt := Origin;
        end;
        dtBrush: ;
        dtSpray: begin

        end;
        dtText: ;
        dtLine: ;
        dtCurve: ;
        dtRect: ;
        dtPolyRect: ;
        dtCircle: ;
        dtRoundRect: ;
      end;


end;

procedure TfrmPaint32.ImgViewMouseMove(Sender: TObject; Shift: TShiftState;
  X, Y: Integer; Layer: TCustomLayer);
var myPoint: TPoint;
    b: tbitmap;
begin
     myPoint:=ImgView.ControlToBitmap(Point(X,Y));
     StatusBar.Panels[2].Text:= Format('%d,%d', [myPoint.X,myPoint.Y]);

     if  MDrawType=dtZoom then ShowMagnifier(myPoint.X,myPoint.Y);


    //if(MDrawType=dtSelectArea) and Assigned(Sel) then PaintBox.Cursor := Sel.GetResizeCursor(X, Y, 5);

    if  MDrawType=dtZoom then ShowMagnifier(X,Y);

    if MDrawing then begin
        case MDrawType of
            dtPasteRegion : ;
            dtSelectFreeArea: ;
            dtSelectArea: begin
                  //Sel.MouseMove(Point(X, Y));
                  //PaintBox.Canvas.Draw(0,0,ImageWork.Picture.Graphic);
            end;
            dtEraser:begin
                if ssLeft in Shift then begin
                    ImgView.Bitmap.Canvas.Brush.Color:=pnlColorBG.Color;
                    ImgView.Bitmap.Canvas.Brush.Style:=bsSolid;
                    ImgView.Bitmap.Canvas.Pen.Color:=pnlColorBG.Color;
                    ImgView.Bitmap.Canvas.Rectangle(myPoint.X,myPoint.Y,myPoint.X+EraserHeight,myPoint.Y+EraserHeight);
                    imgBackground.Refresh;
                end;
            end;
            dtFill: ImgView.Cursor:=crFill;
            dtGetColor: begin
                try
                   pnlOptions.Color:=ImgView.Canvas.Pixels[X,Y];
                except
                end;
            end;
            dtZoom: ;
            dtFreeHand: begin
                MovePt := Point(myPoint.X,myPoint.Y);
                DrawFreeHand(Origin, MovePt,MouseButton);
                Origin := Point(myPoint.X,myPoint.Y);
                imgBackground.Refresh;
            end;
            dtBrush: ;
            dtSpray: begin
                 if ssLeft in Shift then Spray(ImgView.Bitmap.Canvas, myPoint.X, myPoint.Y, SprayR, pnlColorFG.Color);
                 if ssRight in Shift then Spray(ImgView.Bitmap.Canvas, myPoint.X, myPoint.Y, SprayR, pnlColorBG.Color);
                 imgBackground.Refresh;
            end;
            dtText: ;
            dtLine: begin
                DrawLine(Origin,MovePt,MouseButton,pmCopy);
                MovePt := Point(myPoint.X,myPoint.Y);
                DrawLine(Origin,MovePt,MouseButton,pmCopy);
                imgBackground.Refresh;
            end;
            dtCurve: ;
            dtRect: begin
                DrawRect(Origin,MovePt,MouseButton,pmCopy);
                MovePt := Point(myPoint.X,myPoint.Y);
                DrawRect(Origin,MovePt,MouseButton,pmCopy);
                imgBackground.Refresh;
            end;
            dtPolyRect: ;
            dtCircle: begin
                DrawCircle(Origin,MovePt,MouseButton,pmCopy);
                MovePt := Point(myPoint.X,myPoint.Y);
                DrawCircle(Origin,MovePt,MouseButton,pmCopy);
                imgBackground.Refresh;
            end;
            dtRoundRect: begin
                DrawRoundRect(Origin,MovePt,MouseButton,pmCopy);
                MovePt := Point(myPoint.X,myPoint.Y);
                DrawRoundRect(Origin,MovePt,MouseButton,pmCopy);
                imgBackground.Refresh;
            end;
        end;
    end;

    { if ssLeft in Shift then begin
       RBLayer.Location:= FloatRect(MouseLastPos.X, MouseLastPos.Y, myPoint.X , myPoint.Y);
     end;}
end;

procedure TfrmPaint32.ImgViewPaintStage(Sender: TObject; Buffer: TBitmap32;
  StageNum: Cardinal);
const
  Colors: array [0..1] of TColor32 = ($FFFFFFFF, $FFB0B0B0);
var
  W, I, J, Parity: Integer;
  Line1, Line2: TArrayOfColor32; // a buffer for a couple of scanlines
begin
  with ImgView.Buffer do
  begin
    W := Width;
    SetLength(Line1, W);
    SetLength(Line2, W);
    for I := 0 to W - 1 do
    begin
      Parity := I shr 3 and $1;
      Line1[I] := Colors[Parity];
      Line2[I] := Colors[1 - Parity];
    end;
    for J := 0 to Height - 1 do
    begin
      Parity := J shr 3 and $1;
      if Boolean(Parity) then MoveLongword(Line1[0], ScanLine[J]^, W)
      else MoveLongword(Line2[0], ScanLine[J]^, W);
    end;
  end;

end;

procedure TfrmPaint32.FormCreate(Sender: TObject);
var reg: TRegistry;
//  L: TPositionedLayer;
begin

{  // chessboard
  with ImgView.PaintStages[0]^ do
  begin
    if Stage = PST_CLEAR_BACKGND then Stage := PST_CUSTOM;
  end;

  RBLayer := TRubberBandLayer.Create(ImgView.Layers);
  RBLayer.MinHeight := 1;
  RBLayer.MinWidth := 1; }

      with screen do begin
          cursors[crPen]:=QCursor_create(imgPen.Picture.Bitmap.handle,0,16);
          cursors[crCross2]:=QCursor_create(imgCross2.Picture.Bitmap.handle,11,11);
          cursors[crGetColor]:=QCursor_create(imgGetColor.Picture.Bitmap.handle,0,16);
          cursors[crFill]:=QCursor_create(imgFill.Picture.Bitmap.handle,3,15);
          cursors[crSpray]:=QCursor_create(imgSpray.Picture.Bitmap.handle,4,16);
          cursors[crZoom]:=QCursor_create(imgZoom.Picture.Bitmap.handle,0,0);
          cursors[crWinDefault]:=QCursor_create(imgWinDefault.Picture.Bitmap.handle,0,0);
          cursors[crErase4]:=QCursor_create(imgErase4.Picture.Bitmap.handle,0,0);
          cursors[crErase6]:=QCursor_create(imgErase6.Picture.Bitmap.handle,0,0);
          cursors[crErase8]:=QCursor_create(imgErase8.Picture.Bitmap.handle,0,0);
          cursors[crErase10]:=QCursor_create(imgErase10.Picture.Bitmap.handle,0,0);
         //Screen.Cursors[crDefault]:=Screen.cursors[crWinDefault];
      end;
      ImgView.Cursor:=crPen;

      OpenDialog.DefaultExt:=GraphicExtension(TBitmap);
      OpenDialog.Filter:=GraphicFilter(TBitmap);
      SaveDialog.DefaultExt:=GraphicExtension(TBitmap);
      SaveDialog.Filter:=GraphicFilter(TBitmap);

      reg := TRegistry.Create();
      try
          if Reg.OpenKey('Software/XPde/paint', false) then begin
              Top := reg.Readinteger('Top');
              Left := reg.Readinteger('Left');
              Height := reg.Readinteger('Height');
              Width := reg.Readinteger('Width');
          end;
      finally
          reg.Free();
      end;



      if paramstr(1)<>'' then OpenImage(paramstr(1))
      else mnuNewClick(Self);


      //Set initial scroll

      Dx:=0;

      Dy:=0;

      //Layer := TBitmapLayer.Create(ImgView.Layers);
      //Layer.Cropped := True;




end;

procedure TfrmPaint32.pnlColor1DblClick(Sender: TObject);
begin
        with Sender as TPanel do
          if ColorDialog.Execute then begin
             Color:=ColorDialog.Color;
        end;
end;

procedure TfrmPaint32.Panel1Click(Sender: TObject);
var tmpcolor: TColor;
begin
     tmpcolor:= pnlColorBG.Color;
     pnlColorBG.Color:=pnlColorFG.Color;
     pnlColorFG.Color:=tmpcolor;
end;

procedure TfrmPaint32.pnlColor1MouseDown(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
    with Sender as TPanel do begin
        if Button=mbLeft then begin
           pnlColorFG.Color:=Color;
           ColorFG:=Color32(Color);
           ImgView.Canvas.Pen.Color :=ColorFG;

        end;
        if Button=mbRight then begin
           pnlColorBG.Color:=Color;
           ColorBG:=Color32(Color);
           ImgView.Canvas.Brush.Color :=ColorBG;
           
        end;
   end;

end;



procedure TfrmPaint32.Open1Click(Sender: TObject);
begin
     if OpenDialog.Execute then OpenImage(OpenDialog.FileName);


end;

procedure TfrmPaint32.PasteFrom1Click(Sender: TObject);
var
  P: TPoint;
  W, H: Single;
begin
  with OpenDialog do
    if Execute then
    begin
      Layer := TBitmapLayer.Create(ImgView.Layers);
      Layer.Cropped := True;
      with Layer do
      try
        Bitmap.LoadFromFile(FileName);
        Bitmap.DrawMode := dmBlend;
        Cursor:=crSizeAll;

        with ImgView.GetViewportRect do
          P :=Point(0,0);
          W := Bitmap.Width;
          H := Bitmap.Height;

          with ImgView.Bitmap do
            Location := FloatRect(P.X, P.Y , P.X + W, P.Y + H);
            Scaled := True;
      except
        Free;
        raise;
      end;
      Selection := Layer;

    MDrawType :=dtPasteRegion;
    //ImgView.Cursor:=crSizeAll;
    btnSelectArea.Down:=True;
    try
       img32Tmp.Bitmap:=Layer.Bitmap;
    except

    end;

    
    DrawTransparentTool(5);
    end;

end;

procedure TfrmPaint32.mnuNewClick(Sender: TObject);
begin
     IsNew:=True;
     ColorBG:=Color32(clWhite);
     ColorFG:=Color32(clBlack);

  with ImgView do
  begin
    Selection := nil;
    RBLayer := nil;
    Layers.Clear;
    Scale := 1;
    Bitmap.SetSize(640, 512);
    Bitmap.Clear(ColorBG);
    //Bitmap.Canvas.Brush.Style:=bsSolid;
    Bitmap.Canvas.Brush.Color :=pnlColorBG.Color;
    BrushType:=1;
    //Bitmap.Canvas.Pen.Style:=psSolid;
    Bitmap.Canvas.Pen.Color :=pnlColorFG.Color;
    //Bitmap.Canvas.Pen.Mode := pmCopy;
    Bitmap.Canvas.Pen.Width:=1;
    gLineWidth:=1;
  end;



  SprayR:=15;
  SprayDens:=50;
  BrushType:=1;
  LastSelectedRect:=1;
  LastSelectedRoundRect:=1;
  LastSelectedCircle:=1;
  LastSelectedPolyRect:=1;
  LastSelectedErase:=1;
  LastSelectedSpray:=1;
  LastSelectedLine:=1;
  LastSelectedZoom:=1;
  EraserHeight:=4;
  TransparenceMode:= tmSolid;


  imgBackground.Picture.Bitmap.Height:=ImgView.Bitmap.Height;
  imgBackground.Picture.Bitmap.Width:=ImgView.Bitmap.Width;
  Bitmap32ToBitmap(ImgView.Bitmap,imgBackground.Picture.Bitmap);

  PreviousTool:=btnPen;
  btnPen.Down:=True;
  SetDrawType(PreviousTool);
  //DrawZoomTool(3);
  SaveDialog.FileName:=DefaultFilename;
  Caption:=DefaultFileName+' - Paint';


{  SprayR:=15;
  SprayDens:=50;
  BrushType:=1;
  LastSelectedRect:=1;
  LastSelectedRoundRect:=1;
  LastSelectedCircle:=1;
  LastSelectedPolyRect:=1;
  LastSelectedErase:=1;
  LastSelectedSpray:=1;
  LastSelectedLine:=1;
  LastSelectedZoom:=1;
  EraserHeight:=1;
  TransparenceMode:= tmSolid;
  PreviousTool:=btnPen;
  MDrawType := dtFreeHand;

  ;
    }


end;

procedure TfrmPaint32.FormShow(Sender: TObject);
begin
     mnuNewClick(Self);
end;

procedure TfrmPaint32.EditColors1Click(Sender: TObject);
begin
        if ColorDialog.Execute then begin
        end;
end;

procedure TfrmPaint32.mnuHelpAboutClick(Sender: TObject);
begin
    XPAPI.ShowAboutDlg('XPde Paint');
end;

procedure TfrmPaint32.mnuSaveClick(Sender: TObject);
var
  b: tbitmap;
begin
     b:=tbitmap.Create;
     b.Handle:=ImgView.Bitmap.Pixmap;
     if IsNew=True  then begin
         if SaveDialog.Execute  then begin
             IsNew:=False;
             b.SaveToFile(SaveDialog.FileName);
         end;
     end
     else b.SaveToFile(SaveDialog.FileName);
     b.Free

end;

procedure TfrmPaint32.mnuSaveAsClick(Sender: TObject);
var
  b: tbitmap;
begin
      if SaveDialog.Execute then begin
          b:=tbitmap.Create;
          b.Handle:=ImgView.Bitmap.Pixmap;
          b.SaveToFile(SaveDialog.FileName);
          b.Free
      end;
end;

procedure TfrmPaint32.mnuCloseClick(Sender: TObject);
begin
    Close;
end;

procedure TfrmPaint32.FormClose(Sender: TObject; var Action: TCloseAction);
begin
     SaveSettings();
     //Sel.free;
     Action:=caFree;

end;

procedure TfrmPaint32.SetDrawType(Sender: TObject);
begin

      if Sender <> btnSelectArea then StatusBar.Panels[1].Text := '';

      
      //if Sender <> btnZoom then TrackBar1.Visible := False;   // New Longhorn zoom style

      //PaintBox.Canvas.Draw(0,0,ImageWork.Picture.Graphic);
      if Sender = btnSelectFreeArea then begin
          MDrawType := dtSelectFreeArea;
          ImgView.Cursor:=crCross2;
          DrawTransparentTool(5);
      end
      else if Sender = btnSelectArea then begin
          MDrawType := dtSelectArea;
          //RStyle := rssNone;
          DrawTransparentTool(5);
      end
      else if Sender = btnEraser then begin
          MDrawType := dtEraser;
          case LastSelectedErase of
            1: DrawEraseTool(3);
            2: DrawEraseTool(16);
            3: DrawEraseTool(27);
            4: DrawEraseTool(47);
          end;
      end
      else if Sender  = btnFill then begin
          MDrawType := dtFill;
          ImgView.Cursor:=crFill;
          ClearOptionsPanel;
      end
      else if Sender  = btnGetColor then begin
          MDrawType := dtGetColor;
          ImgView.Cursor:=crGetColor;
          ClearOptionsPanel;
      end
      else if Sender  = btnZoom then begin
          MDrawType := dtZoom;
          
          //TrackBar1.Visible := True;  // New Longhorn zoom style
          
          case LastSelectedZoom of     // Old Win98/XP zoom style
            1: DrawZoomTool(3);
            2: DrawZoomTool(16);
            3: DrawZoomTool(27);
            4: DrawZoomTool(47);
          end;

      end
      else if Sender  = btnPen then begin
          MDrawType := dtFreeHand;
          ImgView.Cursor:=crPen;
          ClearOptionsPanel;
      end
      else if Sender  = btnBrush then begin
          MDrawType := dtBrush;
          ClearOptionsPanel;
      end
      else if Sender  = btnSpray then begin
          MDrawType := dtSpray;
          ImgView.Cursor:=crSpray;
          case LastSelectedSpray of
            1: DrawSprayTool(3,3);
            2: DrawSprayTool(25,3);
            3: DrawSprayTool(2,27);
          end;

      end
      else if Sender = btnText then begin
          MDrawType := dtText;
          ClearOptionsPanel;
      end
      else if Sender = btnLine then begin
          MDrawType := dtLine;
          ImgView.Cursor:=crCross2;
          case LastSelectedLine of
            1: DrawLineTool(3);
            2: DrawLineTool(25);
            3: DrawLineTool(45);
            4: DrawLineTool(25);
            5: DrawLineTool(45);
          end;

      end
      else if Sender = btnCurve then begin
          MDrawType := dtCurve;
          ClearOptionsPanel;
      end
      else if Sender = btnRect then begin
          MDrawType := dtRect;
          ImgView.Cursor:=crCross2;
          case LastSelectedRect of
            1: DrawRectTool(5);
            2: DrawRectTool(25);
            3: DrawRectTool(45);
          end;
      end
      else if Sender = btnPolyRect then begin
          MDrawType := dtPolyRect;
       end
      else if Sender = btnCircle then begin
          MDrawType := dtCircle;
          ImgView.Cursor:=crCross2;
          case LastSelectedCircle of
            1: DrawRectTool(5);
            2: DrawRectTool(25);
            3: DrawRectTool(45);
          end;
      end
      else if Sender  = btnRoundRect then begin
          MDrawType := dtRoundRect;
          ImgView.Cursor:=crCross2;
          case LastSelectedRoundRect of
            1: DrawRectTool(5);
            2: DrawRectTool(25);
            3: DrawRectTool(45);
          end; 
      end;
    
end;

procedure TfrmPaint32.imgOptionsMouseDown(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
      case MDrawType of
        dtSelectFreeArea: DrawTransparentTool(Y);
        dtSelectArea: DrawTransparentTool(Y);
        dtEraser: DrawEraseTool(Y);
        dtFill: ;
        dtGetColor: ;
        dtZoom: DrawZoomTool(Y);
        dtFreeHand: ;
        dtBrush: ;
        dtSpray: DrawSprayTool(X,Y);
        dtText: ;
        dtLine: DrawLineTool(Y);
        dtCurve: ;
        dtRect: DrawRectTool(Y);
        dtPolyRect: ;
        dtCircle: DrawRectTool(Y);
        dtRoundRect: DrawRectTool(Y);
      end;
end;

procedure TfrmPaint32.ImgViewMouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer; Layer: TCustomLayer);
var myPoint: TPoint;
begin
    myPoint:=ImgView.ControlToBitmap(Point(X,Y));

    if MDrawing then begin
        case MDrawType of
            dtPasteRegion : ;
            dtSelectFreeArea: ;
            dtSelectArea: {Sel.MouseUp};
            dtEraser: begin
                ImgView.Bitmap.Canvas.Brush.Color:=pnlColorBG.Color;
                ImgView.Bitmap.Canvas.Brush.Style:=bsSolid;
                ImgView.Bitmap.Canvas.Pen.Color:=pnlColorBG.Color;
                ImgView.Bitmap.Canvas.Rectangle(myPoint.X,myPoint.Y,myPoint.X+EraserHeight,myPoint.Y+EraserHeight);
                Bitmap32ToBitmap(ImgView.Bitmap,imgBackground.Picture.Bitmap);
                BitmapToBitmap32(imgBackground.Picture.Bitmap,ImgView.Bitmap);
                PreviousTool:=btnEraser;
            end;
            dtFill: begin
                PreviousTool:=btnFill;
                //SetDrawType(PreviousTool);
                //SetUndo;
            end;
            dtGetColor: begin
                 GetColor(Button, X, Y);
                  with PreviousTool as TSpeedButton do begin
                     Down:=True;
                     SetDrawType(PreviousTool);
                  end;
            end;
            dtZoom: ;
            dtFreeHand: begin
                Bitmap32ToBitmap(ImgView.Bitmap,imgBackground.Picture.Bitmap);
                BitmapToBitmap32(imgBackground.Picture.Bitmap,ImgView.Bitmap);
                PreviousTool:=btnPen;
                //SetUndo;
            end;
            dtBrush: begin
                PreviousTool:=btnBrush;
            end;
            dtSpray: begin
                 if ssLeft in Shift then Spray(ImgView.Bitmap.Canvas, myPoint.X, myPoint.Y, SprayR, pnlColorFG.Color);
                 if ssRight in Shift then Spray(ImgView.Bitmap.Canvas, myPoint.X, myPoint.Y, SprayR, pnlColorBG.Color);
                 Bitmap32ToBitmap(ImgView.Bitmap,imgBackground.Picture.Bitmap);
                 BitmapToBitmap32(imgBackground.Picture.Bitmap,ImgView.Bitmap);
                 PreviousTool:=btnSpray;
            end;
            dtText: begin
                PreviousTool:=btnText;
            end;
            dtLine: begin
                DrawLine(Origin,Point(myPoint.X,myPoint.Y),MouseButton,pmCopy);
                Bitmap32ToBitmap(ImgView.Bitmap,imgBackground.Picture.Bitmap);
                BitmapToBitmap32(imgBackground.Picture.Bitmap,ImgView.Bitmap);
                PreviousTool:=btnLine;
                //SetUndo;
            end;
            dtCurve: begin
                PreviousTool:=btnCurve;
            end;
            dtRect: begin
                DrawRect(Origin,Point(myPoint.X,myPoint.Y),MouseButton,pmCopy);
                Bitmap32ToBitmap(ImgView.Bitmap,imgBackground.Picture.Bitmap);
                BitmapToBitmap32(imgBackground.Picture.Bitmap,ImgView.Bitmap);
                PreviousTool:=btnRect;
                //SetUndo;
            end;
            dtPolyRect: begin
                PreviousTool:=btnPolyRect;
            end;
            dtCircle: begin
                DrawCircle(Origin,Point(myPoint.X,myPoint.Y),MouseButton,pmCopy);
                Bitmap32ToBitmap(ImgView.Bitmap,imgBackground.Picture.Bitmap);
                BitmapToBitmap32(imgBackground.Picture.Bitmap,ImgView.Bitmap);
                PreviousTool:=btnCircle;
                //SetUndo;
            end;
            dtRoundRect: begin
                DrawRoundRect(Origin,Point(myPoint.X,myPoint.Y),MouseButton,pmCopy);
                Bitmap32ToBitmap(ImgView.Bitmap,imgBackground.Picture.Bitmap);
                BitmapToBitmap32(imgBackground.Picture.Bitmap,ImgView.Bitmap);
                PreviousTool:=btnRoundRect;
                //SetUndo;
            end;

        end;
   end;
        MDrawing := False;

end;

procedure TfrmPaint32.ColorBoxMouseMove(Sender: TObject;
  Shift: TShiftState; X, Y: Integer);
begin
          Screen.Cursor:=crDefault;
          ColorBox.Cursor:=crDefault;
          Application.ProcessMessages;
end;

procedure TfrmPaint32.ImgViewMouseWheelUp(Sender: TObject;
  Shift: TShiftState; MousePos: TPoint; var Handled: Boolean);
begin
     ImgView.Scroll(Dx,Dy-40);
end;

procedure TfrmPaint32.ImgViewMouseWheelDown(Sender: TObject;
  Shift: TShiftState; MousePos: TPoint; var Handled: Boolean);
begin
   ImgView.Scroll(Dx,Dy+40);
end;

procedure TfrmPaint32.TrackBar1Change(Sender: TObject);
begin
      case TrackBar1.Position of
        0: ImgView.Scale:=0.1;
        1: ImgView.Scale:=0.25;
        2: ImgView.Scale:=0.5;
        3: ImgView.Scale:=0.75;
        4: ImgView.Scale:=1;
        5: ImgView.Scale:=2;
        6: ImgView.Scale:=3;
        7: ImgView.Scale:=4;
        8: ImgView.Scale:=6;
        9: ImgView.Scale:=8;
        10: ImgView.Scale:=16;
      end;



end;

procedure TfrmPaint32.Copy1Click(Sender: TObject);
begin
      try
         Clipboard.Assign(ImgView.Bitmap);
      except

      end;

end;

procedure TfrmPaint32.ImgViewDblClick(Sender: TObject);
var
  B: TBitmap32;
  W, H: Integer;
begin
      if MDrawType= dtPasteRegion then begin
          { deselect everything }
          Selection := nil;
          W := ImgView.Bitmap.Width;
          H := ImgView.Bitmap.Height;

          { Create a new bitmap to store a flattened image }
          B := TBitmap32.Create;
          try
            B.SetSize(W, H);
            ImgView.PaintTo(B, Rect(0, 0, W, H));

            { destroy all the layers of the original image... }
            ImgView.Layers.Clear;
            Layer := nil; // note that RBLayer reference is destroyed here as well.
                            // The rubber band will be recreated during the next
                            // SetSelection call. Alternatively, you can delete
                            // all the layers except the rubber band.

            { ...and overwrite it with the flattened one }
            ImgView.Bitmap := B;
            ImgView.Changed;
            Bitmap32ToBitmap(B,imgBackground.Picture.Bitmap);
            imgBackground.Refresh;
          finally
            B.Free;
          end;
      end;
      ImgView.Cursor:=crCross2;

end;

procedure TfrmPaint32.Attributes1Click(Sender: TObject);
begin
     AttributesForm.ShowModal;
end;

procedure TfrmPaint32.FlipRotate1Click(Sender: TObject);
begin
     FlipForm.Show;
end;

procedure TfrmPaint32.StretchSkew1Click(Sender: TObject);
begin
     StretchForm.Show;
end;

end.
